<?php

/**********************************************************************
	CLASS:	URL
	PURPOSE:	handles specific processing for document objects
**********************************************************************/
class DOCMGR_WORKFLOW extends DOCMGR 
{

  /*******************************************************************************
  	called from DOCMGR class
	*******************************************************************************/

  /********************************************************************
  	FUNCTION: getlist
  	PURPOSE:  retrieves document from the system
	********************************************************************/
	public function getlist() 
	{

		$sql = "SELECT * FROM docmgr.dm_workflow WHERE object_id='".$this->objectId."'";
		$list = $this->DB->fetch($sql);
		
		for ($i=0;$i<$list["count"];$i++) 
		{
		
			$list[$i]["status_view"] = $this->viewStatus($list[$i]["status"]);	
			$date = explode(" ", $list[$i]["date_create"]);
			$list[$i]["date_create_view"] = dateView($date[0]);
			$list[$i]["date_time_create_view"] = dateView($list[$i]["date_create"]);
			$date = explode(" ", $list[$i]["date_complete"]);
			$list[$i]["date_complete_view"] = dateView($date[0]);
			$list[$i]["date_time_complete_view"] = dateView($list[$i]["date_complete"]);

			$this->PROTO->add("workflow",$list[$i]);
			
		}

	}

	public function create()
	{
	
		return $this->getinfo(1);
	
	}

	public function getinfo($new=null) {

		if ($new) 
		{
		
			//create a new workflow w/ the default values
			$opt = null;
			$opt["object_id"] = $this->objectId;
			$opt["status"] = "nodist";
			$opt["account_id"] = USER_ID;
			$opt["date_create"] = date("Y-m-d H:i:s");
			$workId = $this->DB->insert("docmgr.dm_workflow",$opt,"id");
				
		} else $workId = $this->apidata["workflow_id"];

		$sql = "SELECT * FROM docmgr.dm_workflow WHERE id='".$workId."'";
		$info = $this->DB->single($sql);
		
		if (!$info) $this->throwError("Error finding workflow information");
		else 
		{

			//recipients
			$sql = "SELECT * FROM docmgr.dm_workflow_route WHERE workflow_id='$workId'";
			$reciplist = $this->DB->fetch($sql);
		
			//translate status
			$info["status_view"] = $this->viewStatus($info["status"]);	
			$date = explode(" ", $info["date_create"]);
			$info["date_create_view"] = dateView($date[0]);
			$info["date_time_create_view"] = dateView($info["date_create"]);
			$date = explode(" ", $list[$i]["date_complete"]);
			$info["date_complete_view"] = dateView($date[0]);
			$info["date_time_complete_view"] = dateView($info["date_complete"]);


			for ($i=0;$i<$reciplist["count"];$i++) 
			{

				$accountinfo = returnAccountInfo($reciplist[$i]["account_id"]);

				$reciplist[$i]["date_due_view"] = dateView($reciplist[$i]["date_due"]);
				$reciplist[$i]["date_complete_view"] = dateView($reciplist[$i]["date_complete"]);
				$reciplist[$i]["account_name"] = $accountinfo["first_name"]." ".$accountinfo["last_name"];
				$reciplist[$i]["account_login"] = $accountinfo["login"];
				$reciplist[$i]["status_view"] = $this->viewStatus($reciplist[$i]["status"]);
	
				$info["recipient"][$i] = $reciplist[$i];
			
			}

			$this->PROTO->add("workflow",$info);
			
		}

	}

	protected function viewStatus($stat) 
	{
	
			$view = null;
			
			if ($stat=="forcecomplete") $view = "Force Complete";
			else if ($stat=="nodist") $view = "Not Distributed";
			else if ($stat=="pending") $view = "In Progress";
			else if ($stat=="complete") $view = "Completed";
			else $view = "Not Distributed";
				
			return $view;
	}

	public function getRecips() 
	{
	
		$sql = "SELECT * FROM docmgr.dm_workflow_route WHERE workflow_id='".$this->apidata["workflow_id"]."'
											ORDER BY sort_order";
		$reciplist = $this->DB->fetch($sql);

		for ($i=0;$i<$reciplist["count"];$i++) {
		
			$accountinfo = returnAccountInfo($reciplist[$i]["account_id"]);

			$ddarr = explode(" ",$reciplist[$i]["date_due"]);
			$dcarr = explode(" ",$reciplist[$i]["date_complete"]);

			$reciplist[$i]["date_due_view"] = dateView($ddarr[0]);
			$reciplist[$i]["date_complete_view"] = dateView($dcarr[0]);
			$reciplist[$i]["account_name"] = $accountinfo["first_name"]." ".$accountinfo["last_name"];
			$reciplist[$i]["account_login"] = $accountinfo["login"];
			
			$this->PROTO->add("recipient",$reciplist[$i]);
		
		}

	}
	
	public function saveRecip() {
	
		$this->DB->begin();

		$accountId = $this->apidata["accountId"];
		if (!is_array($accountId)) $accountId = array($accountId);

		if ($this->apidata["route_id"]) 
		{
		
			$opt = null;
			$opt["task_type"] = $this->apidata["taskType"];
			$opt["task_notes"] = $this->apidata["taskNotes"];
			$opt["date_due"] = dateProcess($this->apidata["dateDue"]);
			$opt["where"] = "id='".$this->apidata["route_id"]."'";
			$this->DB->update("docmgr.dm_workflow_route",$opt);
		
		} else {
		
			for ($i=0;$i<count($accountId);$i++) 
			{
			
				$opt = null;
				$opt["workflow_id"] = $this->apidata["workflow_id"];
				$opt["account_id"] = $accountId[$i];
				$opt["task_type"] = $this->apidata["taskType"];
				$opt["task_notes"] = $this->apidata["taskNotes"];
				$opt["date_due"] = dateProcess($this->apidata["dateDue"]);
				$opt["sort_order"] = $this->apidata["stage"];
				$opt["status"] = "nodist";
				$this->DB->insert("docmgr.dm_workflow_route",$opt);
		
			}

		}

		$this->consolidate();
		
		$this->DB->end();

		$err = $this->DB->error();
		
		if ($err) $this->throwError($err);
	
	}

	public function deleteRecip() 
	{

		$this->DB->begin();
			
		$sql = "DELETE FROM docmgr.dm_workflow_route WHERE id='".$this->apidata["route_id"]."'";
		$this->DB->query($sql);
		
		$this->consolidate();
		
		$this->DB->end();
		
		$err = $this->DB->error();
		if ($err) $this->throwError($err);

	}	

	//keeps everything in order in case someone gets goofy w/ the adding of stuff
	protected function consolidate() 
	{

		$sql = "SELECT DISTINCT sort_order FROM docmgr.dm_workflow_route WHERE workflow_id='".$this->apidata["workflow_id"]."' ORDER BY sort_order"; 
		$list = $this->DB->fetch($sql);
		
		for ($i=0;$i<$list["count"];$i++) 
		{
		
			$so = $list[$i]["sort_order"];

			$sql = "SELECT id FROM docmgr.dm_workflow_route WHERE sort_order='$so' AND workflow_id='".$this->apidata["workflow_id"]."' ORDER BY id";
			$matches = $this->DB->fetch($sql,1);
			
			$sql = "UPDATE docmgr.dm_workflow_route SET sort_order='".($i)."' WHERE id IN (".implode(",",$matches["id"]).")";
			$this->DB->query($sql);
			
		}
	
	}

	//set workflow options
	public function setOpt() 
	{
	
		//emailcomplete, emailexpired
		if ($this->apidata["option"]=="emailcomplete") $field = "email_notify";
		else $field = "expire_notify";
		
		if ($this->apidata["action"]=="set") $val = "t";
		else $val = "f";
		
		$opt = null;
		$opt[$field] = $val;
		$opt["where"] = "id='".$this->apidata["workflow_id"]."'";
		$this->DB->update("docmgr.dm_workflow",$opt);
		
		$err = $this->DB->error();
		if ($err) $this->throwError($err);
		
	
	}	

	//transfer all the current routes into a template
	protected function transferTemplate($templateId) 
	{

		$workflowId = $this->apidata["workflow_id"];

  	$sql = "SELECT * FROM docmgr.dm_workflow_route WHERE workflow_id='$workflowId'";
  	$list = $this->DB->fetch($sql);
  
  	//delete any current template info
  	$sql = "DELETE FROM docmgr.dm_saveroute_data WHERE save_id='$templateId';";

  	//get the time in seconds
  	$today = time();
  
  	for ($i=0;$i<$list["count"];$i++) 
  	{

    	//get the date in seconds
    	$sec = strtotime($list[$i]["date_due"]);
    
    	$diff = $sec - $today;
    	$days = intValue($diff/86400);
    	if (!$days) $days = "0";
  
    	$opt = null;
    	$opt["save_id"] = $templateId;
    	$opt["account_id"] = $list[$i]["account_id"];
    	$opt["task_type"] = $list[$i]["task_type"];
    	$opt["task_notes"] = addslashes($list[$i]["task_notes"]);
    	$opt["sort_order"] = $list[$i]["sort_order"];
    	$opt["date_due"] = $days;
    	$opt["query"] = 1;
    	$sql .= $this->DB->insert("docmgr.dm_saveroute_data",$opt);

		}

		$this->DB->query($sql);

	}
	
	public function saveTemplate() 
	{

		$this->DB->begin();

    $opt = null;

    if ($this->apidata["template_id"]) 
    {

			$templateId = $this->apidata["template_id"];    
    	$opt["where"] = "id='".$templateId."'";
    	$this->DB->update("docmgr.dm_saveroute",$opt);
    
    } else 
    {

	    $opt["account_id"] = USER_ID;
	    $opt["name"] = $this->apidata["template_name"];
	    $templateId = $this->DB->insert("docmgr.dm_saveroute",$opt,"id");

		}
		
    $this->transferTemplate($templateId);

    $this->DB->end();

		$err = $this->DB->error();
		if ($err) $this->throwError($err);

  }  

  public function getTemplates() 
  {
  
  	//get all saved templates for this user
  	$sql = "SELECT * FROM docmgr.dm_saveroute WHERE account_id='".USER_ID."'";
  	$tempList = $this->DB->fetch($sql);
  	
  	for ($i=0;$i<$tempList["count"];$i++) 
  	{
  
  		$this->PROTO->add("template",$tempList[$i]);
  		
		}
		
	}

	function deleteTemplate() {
	
		$sql = "DELETE FROM docmgr.dm_saveroute_data WHERE save_id='".$this->apidata["template_id"]."';";
		$sql .= "DELETE FROM docmgr.dm_saveroute WHERE id='".$this->apidata["template_id"]."';";
		$this->DB->query($sql);

		$err = $this->DB->error();
		if ($err) $this->throwError($err);
		
	}	

	public function getFromTemplate() 
	{

		$this->DB->begin();
		
		//transfer saveroute data into workflow data
		$sql = "SELECT * FROM docmgr.dm_saveroute_data WHERE save_id='".$this->apidata["template_id"]."'
											ORDER BY sort_order";
		$reciplist = $this->DB->fetch($sql);

		$sql = "DELETE FROM docmgr.dm_workflow_route WHERE workflow_id='".$this->apidata["workflow_id"]."'";
		$this->DB->query($sql);
		
		for ($i=0;$i<$reciplist["count"];$i++) 
		{
		
			//calculate the date due
			$time = time();
			$diff = $time + ($list[$i]["date_due"] * 86400);
			$dateDue = date("Y-m-d H:i:s",$diff);

			//rn the insert
			$opt = null;
			$opt["workflow_id"] = $this->apidata["workflow_id"];
			$opt["account_id"] = USER_ID;
			$opt["task_type"] = addslashes($reciplist[$i]["task_type"]);
			$opt["status"] = "nodist";
			$opt["sort_order"] = $reciplist[$i]["sort_order"];
			$opt["task_notes"] = addslashes($reciplist[$i]["task_notes"]);			
			$opt["date_due"] = $dateDue;
			$this->DB->insert("docmgr.dm_workflow_route",$opt);
		
		}

		//pull the info to show the new routes
		$this->getRecips();

		$this->DB->end();
		
		$err = $this->DB->error();
		if ($err) $this->throwError($err);

	}

	//issue our alerts for a specific stage of a route
	public function begin($stage="0") 
	{
	
		$workflowId = $this->apidata["workflow_id"];
		$this->DB->begin();
		
	  //get our list of routes assigned to this object
	  $sql = "SELECT * FROM docmgr.dm_workflow_route WHERE workflow_id='$workflowId' AND sort_order='$stage';";
	  $list = $this->DB->fetch($sql);

		if ($list["count"]==0) 
		{

		    //see if we are supposed to notify the user this is complete
		    $this->sendCompleteNotify();

		    $sql = "UPDATE docmgr.dm_workflow SET status='complete',date_complete='".date("Y-m-d H:i:s")."' WHERE id='$workflowId';";
		    $this->DB->query($sql);
	
	  } 
	  else 
	  {

	  	//starting a new one
	  	if ($stage=="0") logEvent(OBJ_WORKFLOW_BEGIN,$this->objectId);

	 	  //make sure our primary status is still set to pending since we are not done
	 	  $sql = "Update docmgr.dm_workflow SET status='pending' WHERE id='$workflowId';";
			$this->DB->query($sql);
			
			$accounts = array();	
			$objname = $this->objectInfo["name"];
			
	  	for ($i=0;$i<$list["count"];$i++) {

				$sql = "UPDATE docmgr.dm_workflow_route SET status='pending' WHERE id='".$list[$i]["id"]."';";
				$this->DB->query($sql);

		    if ($list[$i]["task_type"]=="edit") $msg = "Edit action required for \"".$objname."\"";
		    elseif ($list[$i]["task_type"]=="approve") $msg = "Approval action required for \"".$objname."\"";
		    elseif ($list[$i]["task_type"]=="comment") $msg = "Comment action required for \"".$objname."\"";
		    else $msg = "View action required for \"".$objname."\"";		

				//setup a task
				//gather our data
				$opt = null;
				$opt["title"] = addslashes($msg);
				$opt["notes"] = null;
				$opt["priority"] = "1";
				$opt["taskType"] = "docmgr";
				$opt["accountId"] = $list[$i]["account_id"];
				$opt["routeId"] = $list[$i]["id"];
				$opt["workflowId"] = $list[$i]["workflow_id"];
				$opt["objectId"] = $this->objectId;

				if ($list[$i]["date_due"]) 
				{
					$opt["dateDue"] = $list[$i]["date_due"];
					$opt["due"] = "t";
				} else {
					$opt["due"] = "f";				
				}

				$t = new TASK();
				$t->save($opt);
				
			}
		
		}	

		$this->DB->end();
		
		$err = $this->DB->error();
		if ($err) $this->throwError($err);
			  
	}
	
	
	protected function sendCompleteNotify($rejected=null) {
	
			$workflowId = $this->apidata["workflow_id"];
			
	    //see if we are supposed to notify the user this is complete
	    $sql = "SELECT object_id,account_id,email_notify FROM docmgr.dm_workflow WHERE id='$workflowId'";
	    $info = $this->DB->single($sql);

	    //log that it's finished
      logEvent(OBJ_WORKFLOW_END,$info["object_id"]);
	    
	    if ($info["email_notify"]=="t") 
	    {
	    
	      //get the user's email and send them a notification
	      $ainfo = returnAccountInfo($info["account_id"]);
	      if ($ainfo["email"]) {

	      	//send a rejected message if workflow was stopped that way
					if ($rejected) 
					{
						
	        	$sub = "Workflow Rejected";
	        	$msg = $this->objectInfo["name"]." was rejected by ".USER_FN." ".USER_LN;

					//send a completed message	      
					} else {
					
						$sub = "Workflow Completed";
	        	$msg = $this->objectInfo["name"].": Workflow was completed";
						
					}
					
	        send_email($ainfo["email"],ADMIN_EMAIL,$sub,$msg,null);
	      
	      }
	    
	    }
	
	}
	
	public function forceComplete() 
	{

		$workflowId = $this->apidata["workflow_id"];

		$this->DB->begin();
		
		$sql = "SELECT id FROM docmgr.dm_workflow_route WHERE workflow_id='$workflowId';";
		$list = $this->DB->fetch($sql,1);
	
		//delete the tasks
		//$sql = "DELETE FROM docmgr.dm_task WHERE task_id IN (".implode(",",$list["id"]).");";
		$sql = "UPDATE docmgr.dm_workflow_route SET status='forcecomplete' WHERE workflow_id='$workflowId' AND status!='complete';";
		$sql .= "UPDATE docmgr.dm_workflow SET status='forcecomplete',date_complete='".date("Y-m-d H:i:s")."' WHERE id='$workflowId';";
	
		$this->DB->query($sql);

  	//mark our tasks as complete if they have not been already
  	$sql = "SELECT id FROM task.view_docmgr_task WHERE workflow_id='".$workflowId."' AND completed='f'";                          
  	$tasks = $this->DB->fetch($sql);
  	
  	for ($i=0;$i<$tasks["count"];$i++) 
  	{
  	
  		$t = new TASK($tasks[$i]["id"]);
  		$t->markComplete("Forced Complete");	//puts a comment showing this was forced closed
  	
  	}

		//log that it's completed
	  $sql = "SELECT object_id FROM docmgr.dm_workflow WHERE id='$workflowId'";
	  $info = $this->DB->single($sql);

		logEvent(OBJ_WORKFLOW_CLEAR,$info["object_id"]);

		$this->DB->end();
		
		$err = $this->DB->error();
		if ($err) $this->throwError($err);
	
	}

	public function markComplete() 
	{

		$this->DB->begin();

		//update this route and delete the task from the alert
		$opt = null;
		$opt["status"] = "complete";
		$opt["comment"] = smartslashes($this->apidata["taskComment"]);
		$opt["where"] = "id='".$this->apidata["route_id"]."'";
		$this->DB->update("docmgr.dm_workflow_route",$opt);

  	//mark our tasks as complete if they have not been already
  	$sql = "SELECT id FROM task.view_docmgr_task WHERE route_id='".$this->apidata["route_id"]."' AND completed='f'";                          
  	$tasks = $this->DB->fetch($sql);
  	
  	for ($i=0;$i<$tasks["count"];$i++) 
  	{
  	
  		$t = new TASK($tasks[$i]["id"]);
  		$t->markComplete($this->apidata["taskComment"]);	//puts a comment showing this was forced closed
  	
  	}

		//figure out how many other tasks are left at this level
		$sql = "SELECT sort_order,workflow_id,task_type,
							(SELECT object_id FROM docmgr.dm_workflow WHERE id=workflow_id) AS object_id
							 FROM docmgr.dm_workflow_route WHERE id='".$this->apidata["route_id"]."';";
		$info = $this->DB->single($sql);

		$sql = "SELECT id FROM docmgr.dm_workflow_route WHERE workflow_id='".$info["workflow_id"]."' 
								AND sort_order='".$info["sort_order"]."' AND status!='complete'";
		$list = $this->DB->fetch($sql);

		//set for beginWorkflow() later
		$this->apidata["workflow_id"] = $info["workflow_id"];
		
		//if there are some left at this level, do nothing.If there are not, queue the approvers at the next stage
		if ($list["count"]=="0") {

			$nextOrder = $info["sort_order"] + 1;

			//queue the tasks for the next stage.If this returns false, there are no objects left
			$this->begin($nextOrder);

		}

		//log in the object's logs
		if ($info["task_type"]=="approve") $lt = OBJ_WORKFLOW_APPROVE;
		else if ($info["task_type"]=="edit") $lt = OBJ_WORKFLOW_EDIT;
		else $lt = OBJ_WORKFLOW_VIEW;
		
		logEvent($lt,$info["object_id"]);

  	$this->DB->end();
  	
  	$err = $this->DB->error();
  	if ($err) $this->throwError($err);

	}

	public function rejectApproval() 
	{

		$routeId = $this->apidata["route_id"];
		$workflowId = $this->apidata["workflow_id"];
		
		$this->DB->begin();

		//figure out how many other tasks are left at this left
		$sql = "SELECT sort_order FROM docmgr.dm_workflow_route WHERE id='$routeId';";
		$info = $this->DB->single($sql);

		//update this route and delete the task from the alert
		$sql = "UPDATE docmgr.dm_workflow_route SET status='rejected',comment='".smartslashes($this->apidata["taskComment"])."' WHERE id='$routeId';";
		$sql .= "UPDATE docmgr.dm_workflow SET status='rejected',date_complete='".date("Y-m-d H:i:s")."' WHERE id='".$workflowId."';";
		$this->DB->query($sql);

  	//mark our tasks as complete if they have not been already
  	$sql = "SELECT id FROM task.view_docmgr_task WHERE workflow_id='".$workflowId."' AND completed='f'";                          
  	$tasks = $this->DB->fetch($sql);
  	
  	for ($i=0;$i<$tasks["count"];$i++) {
  	
  		$t = new TASK($tasks[$i]["id"]);
  		$t->markComplete("Object Rejected");	//puts a comment showing this was forced closed
  	
  	}
  	
  	//notify the user it's done
  	$this->sendCompleteNotify(1);

		//log that it's completed
	  $sql = "SELECT object_id FROM docmgr.dm_workflow WHERE id='$workflowId'";
	  $info = $this->DB->single($sql);

  	logEvent(OBJ_WORKFLOW_REJECT,$info["object_id"]);

  	$this->DB->end();
  	
  	$err = $this->DB->error();
  	if ($err) $this->throwError($err);

	}

	//get all tasks for this user
	public function gettasks() 
	{
	
		//get the current stage we are on
		$sql = "SELECT view_docmgr_task.*,
						(SELECT task_type FROM docmgr.dm_workflow_route where id=route_id) AS route_task_type,
						(SELECT account_id FROM docmgr.dm_workflow WHERE id=workflow_id) AS workflow_account_id
						 FROM task.view_docmgr_task 
						LEFT JOIN task.task_account ON (view_docmgr_task.id = task_account.task_id)		
						WHERE object_id='".$this->objectId."' AND account_id='".USER_ID."' AND route_id IN 
						(
						SELECT id FROM docmgr.dm_workflow_route 
							WHERE object_id=(SELECT object_id FROM docmgr.dm_workflow WHERE dm_workflow.id=dm_workflow_route.workflow_id)
							AND status='pending'
						)";
						
		$routes = $this->DB->fetch($sql);

			for ($i=0;$i<$routes["count"];$i++) 
			{

				$info = returnAccountInfo($routes[$i]["workflow_account_id"]);
				$routes[$i]["workflow_account_name"] = $info["first_name"]." ".$info["last_name"];
				$routes[$i]["workflow_account_login"] = $info["login"];
				if ($routes[$i]["date_due"] > '1980-01-01') $routes[$i]["date_due"] = dateView($routes[$i]["date_due"]);
				else $routes[$i]["date_due"] = null;

				$this->PROTO->add("task",$routes[$i]);

			}
	
	}
	
}
	