/*************************************************
	FILENAME: common.js
	PURPOSE:  contains miscellaneous common
						site-specific javascript functions
*************************************************/

var pageLoadArr = new Array();
var moduleNav;
var moduleNavCtrl;
var moduleNavFooter;
var logintimer;
var docmgrtimer;
var siteFileUpload = 0;			//set this when uploading a file to prevent other background processes from running
var sitepopupref;

/*************************************************
	FUNCTION: performTask
	PURPOSE:  opens task module to perform specified task
	INPUTS:		taskId -> id of task to perform
*************************************************/

function performTask(taskId) {

	var parms = centerParms(700,600,1) + ",scrollable=yes,resizable=yes";

	var url = "index.php?module=managetasks&hideHeader=1&taskId=" + taskId;
	var ref = window.open(url,"_task",parms);
	ref.focus();

}

/*************************************************
	FUNCTION: createNewTask
	PURPOSE:  opens addtask module to create new task
*************************************************/

function createNewTask() {

	var parms = centerParms(600,450,1) + ",scrollable=yes,resizable=yes";

	var url = "index.php?module=managetasks&hideHeader=1";
	var ref = window.open(url,"_task",parms);
	ref.focus();

}

/*************************************************
	FUNCTION: switchLocation
	PURPOSE:  opens addtask module to create new task
*************************************************/

function switchLocation() {

	//make sure we aren't in a banned module
	var banned = new Array("editcontact","editcontract");
	var key = arraySearch(MODULE,banned);

	if (key!=-1) {
		alert("You cannot switch locations while in this module");
	} else {

		var ref = ge("locSwitchDiv");
	
		if (ref.style.display == "block") {
			ref.style.display = "none";
		}
		else {

			ref.style.display = "block";

			if (ref.innerHTML.length == 0)  {
	
				ref.appendChild(ce("div","statusMessage","","Loading Locations"));
				var url = "index.php?module=loclist";
				protoReq(url,"writeSwitchLocation");

			}

		}

	}

}

function writeSwitchLocation(data) {

	 
	var ref = ge("locSwitchDiv");

	clearElement(ref);

	if (data.error) alert(data.error);
	else if (!data.location) ref.appendChild(ce("div","errorMessage","","Error retrieving locations"));
	else {

		for (var i=0;i<data.location.length;i++) {

			var loc = data.location[i];

			var row = ce("div","","",loc.name);
			setClick(row,"setLocation('" + loc.id + "')");

			ref.appendChild(row);

		}

	}

}

function setLocation(id) {

	var url = location.href;

	if (url.indexOf("?")==-1) url += "?switchLocation=" + id;
	else url += "&switchLocation=" + id;

	location.href = url;

}

function loadUnreadEmail() {

	//if (TOPMODULE!="email") setInterval("getUnreadEmail()","60000");

}

function getUnreadEmail() {

	//if uploading a file, bail
	if (siteFileUpload==1) return false;

	var url = "index.php?module=mbox&action=getunseen&mbox=INBOX";
	protoReq(url,"writeUnreadEmail");
	
}

function writeUnreadEmail(data) {

	 

	var ref = ge("emailModTab");

	if (isData(data.unseen) && data.unseen!="0") ref.innerHTML = "Email (" + data.unseen + ")";
	else ref.innerHTML = "Email";

}


function historyManager(f,t){
	frames["hFrame"].location.href=site_url + "history.php?f="+f+"&t="+t;
}

function historyFunc(f){
	f = f+"()";
	eval(f);
}

function runPageLoader() {

	for (var i=0;i<pageLoadArr.length;i++) {

		eval(pageLoadArr[i]);

	}

	//empty page load array
	pageLoadArr = new Array();

}

function siteViewFile(id,type,ext) {

	//handle files we can view inline
	if (type=="document" || (DSOFRAMER_ENABLE==1 && document.all && arraySearch(ext,DSO_FILES)!="-1")) {   

		var url = "index.php?module=editor&objectId=" + id;
		var parms = centerParms(800,600,1) + ",resizable=1";
		sitepopupref = window.open(url,"_editor",parms);

		//if no popup, they probably have a popup blocker
		if (!sitepopupref)
		{
			alert("It appears you have a popup-blocker installed.  Please disable for this site");
		}
		else
		{
			sitepopupref.focus();
		}

	//download like normal
	} else {

		//setup the xml
		var p = new PROTO();
		p.add("command","docmgr_file_get");
		p.add("object_id",id);
		p.redirect(DOCMGR_API);

	}

}  

function downloadFile(objPath) {
	siteViewFile(objPath,"other","file");
}

function c2c(dest) {

	var parms = centerParms(350,175,1);
	var url = "index.php?module=clicktocall&calldest=" + dest;
	var ref = window.open(url,"_c2c",parms);
	ref.focus();

}

function setupModNav() {

	//nav div
	var refname = TOPMODULE + "ModuleNav";
	moduleNav = ge(refname);

	//control div 
	var ctrlname = TOPMODULE + "ModuleCtrl";
	moduleNavCtrl = ge(ctrlname);

	//footer div 
	var ctrlname = TOPMODULE + "ModuleFooter";
	moduleNavFooter = ge(ctrlname);

}

function showModNav() {

	var refname = TOPMODULE + "ModuleNav";
	moduleNav = ge(refname);

	if (!moduleNav) return false;

	clearElement(moduleNav);

	moduleNav.style.display = "block";

}

function showModCtrl() {

	var refname = TOPMODULE + "ModuleCtrl";
	moduleNavCtrl = ge(refname);

	clearElement(moduleNavCtrl);
	moduleNavCtrl.style.display = "block";

}

function hideModCtrl() {

	var refname = TOPMODULE + "ModuleCtrl";
	moduleNavCtrl = ge(refname);

	clearElement(moduleNavCtrl);
	moduleNavCtrl.style.display = "none";

}

function showModFooter() {

	var refname = TOPMODULE + "ModuleFooter";
	moduleNavFooter = ge(refname);

	clearElement(moduleNavFooter);

	moduleNavFooter.style.display = "block";

}

function hideModFooter() {

	var refname = TOPMODULE + "ModuleFooter";
	moduleNavFooter = ge(refname);

	clearElement(moduleNavFooter);

	moduleNavFooter.style.display = "none";

}

function siteToolbarBtn(txt,clickfunc,img,id) {

	if (BROWSER=="safari") var cn = "safariSiteToolbarBtn";
	else if (BROWSER=="ie") var cn = "ieSiteToolbarBtn";	
	else var cn = "siteToolbarBtn";

	var btn = ce("button",cn);
	btn.setAttribute("type","button"); 

	if (document.all) btn.style.marginTop = "-1px";

	if (clickfunc) {
		clickfunc = clickfunc + "; return false";
		setClick(btn,clickfunc);   
	}

	if (img) {
		var btnimg = ce("img");
		btnimg.setAttribute("align","left");
		btnimg.setAttribute("src",theme_path + "/images/icons/" + img);
		btn.appendChild(btnimg);
	}

	btn.appendChild(ctnode(txt));

	if (id) btn.setAttribute("id",id);

	return btn;

}

function siteToolbarSep() {

	var img = ce("img");
	img.setAttribute("src",theme_path + "/images/tbseparator.png");
	img.style.height = "10px";
	img.style.width = "10px";
	return img;

}

function addModNav(txt,clickfunc,imgsrc,id) {

	if (!moduleNav) return false;

	var linkdiv = ce("div","siteModNavLink");

	if (clickfunc) {
		clickfunc = clickfunc + "; return false";
		setClick(linkdiv,clickfunc);   
	}

	if (imgsrc) {

		var img = ce("img");
		img.setAttribute("src",theme_path + "/images/nav/" + imgsrc);
 
		linkdiv.appendChild(img);

	}

	linkdiv.appendChild(ctnode(txt));

	if (id) linkdiv.setAttribute("id",id);

	moduleNav.appendChild(linkdiv);

}

function addModSpacer() {

	if (!moduleNav) return false;

	var s = ce("div","lcSpacer");
	moduleNav.appendChild(s);
	return s;

}

function startLoginTimer() {

	logintimer = setInterval("loginTimer()","60000");

}

function loginTimer() {

	//if uploading a file, bail
	if (siteFileUpload==1) return false;

	var url = "index.php?module=logintimer";
	protoReq(url,"writeLoginTimer");

}

function writeLoginTimer(data) {

	 

	if (data.time_left <= 0) logoutWarning();

}

function killScreen() {

	var ds = ge("screenKiller");
	var w = getWinWidth();
	var h = getWinHeight();

	if (document.all) h += 200;

	ds.style.width = w + "px";
	ds.style.height = h + "px";
	setClick(ds,"void(0)");

}

function liveScreen() {

	var ds = ge("screenKiller");
	ds.style.width = "0px";
	ds.style.height = "0px";

}

function logoutWarning() {

	killScreen();

	var sm = ge("screenMessage");

	sm.style.width = "300px";
	sm.style.height = "84px";

	var xPos = (getWinWidth()-300) / 2;
	var yPos = (getWinHeight()-84) / 2;

	sm.style.left = xPos + "px";
	sm.style.top = yPos + "px";

	var msg = "Your session has expired.  Press \"Login\" to log back into the system";

	var cont = ce("div","logoutBox");
	var msgdiv = ce("div","logoutMessage","",msg);
	var btndiv = ce("div");

	btndiv.appendChild(createBtn("loginbtn","Login","runTimeout()"));

	cont.appendChild(msgdiv);
	cont.appendChild(btndiv);
	sm.appendChild(cont);

	//clear the timer
	clearInterval(logintimer);
	
}

function runTimeout() {

	location.href = "index.php?timeout=true";

}

function siteFooterBtn(txt,clickfunc,img,id) {

	if (BROWSER=="safari") var cn = "safariSiteFooterBtn";
	else if (BROWSER=="ie") var cn = "ieSiteFooterBtn";	
	else var cn = "siteFooterBtn";

	var btn = ce("button",cn);
	btn.setAttribute("type","button"); 

	if (clickfunc) {
		clickfunc = clickfunc + "; return false";
		setClick(btn,clickfunc);   
	}

	if (img) {
		var btnimg = ce("img");
		btnimg.setAttribute("align","left");
		btnimg.setAttribute("src",theme_path + "/images/icons/" + img);
		btn.appendChild(btnimg);
	}

	btn.appendChild(ctnode(txt));

	if (id) btn.setAttribute("id",id);

	return btn;

}

//log into docmgr
function loginDocmgr() {

	//login, and run in the foreground.  we don't want to go any further until this is done
	if (DOCMGR_AUTHORIZE!=1) 
	{

		var p = new PROTO();
		p.setAsync(false);
		p.add("command","keepalive");

		var url = DOCMGR_API + "?login=" + USER_LOGIN + "&password=" + USER_PASSWORD;
		p.post(url,"writeLoginDocmgr");

	}
	
}

function writeLoginDocmgr(data) {
	
	if (data.error) alert("DocMGR: " + data.error);
	else 
	{

		DOCMGR_AUTHORIZE = 1;
		docmgrtimer = setInterval("docmgrKeepAlive()",DOCMGR_KEEPALIVE);

	}

}

function docmgrKeepAlive() {

		//if uploading a file, bail
		if (siteFileUpload==1) return false;

		var p = new PROTO();
		p.add("command","keepalive");
		p.post(DOCMGR_API,"writeDocmgrKeepAlive");

}

function writeDocmgrKeepAlive(data) {

	 	

	//keepalive threw an error.  bail
	if (data.error) {
		DOCMGR_AUTHORIZE = "";
		clearInterval(docmgrtimer);
		alert(data.error);
	}		

}

function fileExtension(fn) {

	var ext = "";

	var pos = fn.lastIndexOf(".");

	if (pos!=-1) ext = fn.substr(pos+1).toLowerCase();

	return ext;

}

function siteToolbarCell(txt,clickfunc,img) {

  var cell = ce("div","toolbarCell");
  if (clickfunc) setClick(cell,clickfunc);
  
  if (img) {
    var btnimg = ce("img");
    btnimg.setAttribute("align","left");
    btnimg.setAttribute("src",theme_path + "/images/icons/" + img);
    cell.appendChild(btnimg);
  }
   
  cell.appendChild(ctnode(txt));

  return cell;

}
 
function siteToolbarSep() {

  var img = ce("img");
  img.setAttribute("src",theme_path + "/images/tbseparator.png");
  img.style.height = "10px";
  img.style.width = "10px"; 
  return img;

}
 
