/***********************************************
	file for editing object properties
***********************************************/

var histcont;

function loadDocHistory() {

	if (!object) return false;

	updateSiteStatus("Loading history");

	clearElement(content);
	clearElement(tbTitle);
	clearElement(tbBtns);

	runDocHistory();

}

function runDocHistory() {

	var p = new PROTO();
	p.add("command","docmgr_document_gethistory");
	p.add("object_id",object);
	p.post(DOCMGR_API,"writeDocHistory");

}

function writeDocHistory(data) {

	if (histcont) clearElement(histcont);
	clearSiteStatus();

	 
	if (data.error) alert(data.error);
	else if (!data.history) content.appendChild(ce("div","errorMessage","","No entries found to display"));
	else {

		histcont = createTable("historyList");
		content.appendChild(histcont);

		var head = ce("thead");
		var hrow = ce("tr");
		hrow.appendChild(ce("th","objVersion","","Version"));
		hrow.appendChild(ce("th","objModOn","","Modified On"));
		hrow.appendChild(ce("th","objModBy","","Modified By"));
		hrow.appendChild(ce("th","objSize","","Size"));
		hrow.appendChild(ce("th","objNotes","","Notes"));
		hrow.appendChild(ce("th","objOpts","","Options"));

		head.appendChild(hrow);
		histcont.appendChild(head);

		var bd = ce("tbody");
		histcont.appendChild(bd);

		for (var i=0; i<data.history.length;i++) {

			bd.appendChild(createHistoryRow(data.history[i]));

		}

	}

}

function createHistoryRow(entry) {

	var row = ce("tr");

	if (!isData(entry.notes)) entry.notes = "Not entered";

	row.appendChild(ce("td","objVersion","",entry.version));
	row.appendChild(ce("td","objModOn","",entry.view_modified_date));
	row.appendChild(ce("td","objModBy","",entry.view_modified_by));
	row.appendChild(ce("td","objSize","",entry.size));
	row.appendChild(ce("td","objNotes","",entry.notes));

	var opt = ce("td","objOpts");
	opt.appendChild(createOptLink("edit.png","View This Revision","viewThisDoc('" + entry.id + "')"));
	opt.appendChild(createOptLink("checkin.png","Promote To Latest Revision","promote('" + entry.id + "')"));
	opt.appendChild(createOptLink("delete.png","Delete This Revision","deleteDoc('" + entry.id + "')"));

	row.appendChild(opt);
	return row;

}

function createOptLink(imgsrc,title,clickval) {

  var img = ce("img");   
  img.setAttribute("src",theme_path + "/images/docmgr/icons/" + imgsrc);
  img.setAttribute("title",title);
  setClick(img,clickval);

  return img;

}


function saveHistory() {


}

function writeDocAction(data) {

	clearSiteStatus();
	 
	if (data.error) alert(data.error);
	else runDocHistory();

}

function viewThisDoc(id) {

	updateSiteStatus("Loading preview");
	var p = new PROTO();
	p.add("command","docmgr_document_get");
	p.add("object_id",object);
	p.add("document_id",id);
	p.post(DOCMGR_API,"writeViewDoc");

}

function writeViewDoc(data) {

	clearSiteStatus();
	 
	if (data.error) alert(data.error);
	else {

		var ref = openSitePopup(800,600);
		var cont = ce("div","","viewDoc");
		if (data.content) cont.innerHTML = data.content;
		ref.appendChild(cont);

	}

}

function promote(id) {

	updateSiteStatus("Promoting document");
	var p = new PROTO();
	p.add("command","docmgr_document_promote");
	p.add("object_id",object);
	p.add("document_id",id);
	p.post(DOCMGR_API,"writeDocAction");

}

function deleteDoc(id) {

	if (confirm("Are you sure you want to remove this document revision?")) 
	{

		updateSiteStatus("Removing document version");
		var p = new PROTO();
		p.add("command","docmgr_document_removerevision");
		p.add("object_id",object);
		p.add("document_id",id);
		p.post(DOCMGR_API,"writeDocAction");

	}

}
