/***********************************************
	file for editing object properties
***********************************************/

function loadCheckin() {

	if (!object) return false;

	updateSiteStatus("Loading check-out/check-in");

	//if no object data loaded, go get it
	if (!objinfo) 
	{
		objpage = "loadCheckinPage";
		loadObjInfo();
	}
	else loadCheckinPage();


}

function writeCheckinObjInfo(data) {

	 
	if (data.error) alert(data.error);
	else {

		objinfo = data.object[0];
		loadCheckinPage();

	}

}

function loadCHToolbar() {

	clearElement(tbBtns);
	clearElement(tbTitle);

}

function loadCheckinPage() {

	clearSiteStatus();

	clearElement(content);
	loadCHToolbar();

	var lc = ce("div","leftColumn","leftCol");
	var rc = ce("div","rightColumn","rightCol");
	
	content.appendChild(lc);
	content.appendChild(rc);

	//if checked out, show checkin
	if (objinfo.locked=="f")
	{

		var cell = ce("div","checkinCell");
		cell.appendChild(ce("div","formHeader","","Status"));
		cell.appendChild(ctnode("Unlocked"));

		var mo = ce("div","checkinCell");
		mo.appendChild(ce("div","formHeader","","Last Modified"));
		mo.appendChild(ctnode(objinfo.view_last_modified));

		var mb = ce("div","checkinCell");
		mb.appendChild(ce("div","formHeader","","Last Modified By"));
		mb.appendChild(ctnode(objinfo.view_modified_by));

		lc.appendChild(cell);
		lc.appendChild(mo);
		lc.appendChild(mb);

		tbBtns.appendChild(siteToolbarCell("Download And Lock File","checkout()","checkout.png"));
		tbBtns.appendChild(siteToolbarCell("Upload New Revision","loadCheckinForm()","checkin.png"));

	} else {

		var cont = ce("div","leftColumn");

		var cell = ce("div","checkinCell");
		cell.appendChild(ce("div","formHeader","","Status"));
		cell.appendChild(ctnode("Locked"));

		var mb = ce("div","checkinCell");
		mb.appendChild(ce("div","formHeader","","Locked By"));
		mb.appendChild(ctnode(objinfo.lock_owner_name.join(",")));

		var mo = ce("div","checkinCell");
		mo.appendChild(ce("div","formHeader","","Locked On"));
		mo.appendChild(ctnode(objinfo.lock_created));

		var mt = ce("div","checkinCell");
		mt.appendChild(ce("div","formHeader","","Lock Type"));
		mt.appendChild(ctnode(objinfo.lock_type));

		var me = ce("div","checkinCell");
		me.appendChild(ce("div","formHeader","","Locked Expires"));
		me.appendChild(ctnode(objinfo.lock_expires));

		var mc = ce("div","checkinCell");
		mc.appendChild(ce("div","formHeader","","Lock Client"));
		mc.appendChild(ctnode(objinfo.lock_client));

		var mtok = ce("div","checkinCell");
		mtok.appendChild(ce("div","formHeader","","Lock Token"));
		mtok.appendChild(ctnode(objinfo.lock_token));

		lc.appendChild(cell);
		lc.appendChild(mb);
		lc.appendChild(mo);
		lc.appendChild(mt);
		lc.appendChild(me);
		lc.appendChild(mc);
		lc.appendChild(mtok);

		if (isLockOwner(objinfo)) {
			tbBtns.appendChild(siteToolbarCell("Upload New Revision","loadCheckinForm()","checkin.png"));
		}

		if (isLockOwner(objinfo) || objinfo.bitmask_text=="admin") {
			tbBtns.appendChild(siteToolbarCell("Clear Lock","clearCheckout()","save.png"));
		}

		//if passed directly to this page, load the checkin form
		if (ge("pageLoad").value="loadCheckin") loadCheckinForm();

	}

}

function clearCheckout() {

	if (confirm("Are you sure you want to remove the lock for this file?")) {

		var p = new PROTO();
		p.add("command","docmgr_lock_clear");
		p.add("object_id",object);
		p.post(DOCMGR_API,"writeClearCheckout");

	}

}

function writeClearCheckout(data) {

	if (data.error) alert(data.error);
	else 
	{
		objpage = "loadCheckinPage";
		loadObjInfo();
	}

}

function loadCheckinForm() {

	//make sure the user has permissions
	if ((objinfo.locked=="t" && isLockOwner(objinfo)) || objinfo.bitmask_text=="edit" || objinfo.bitmask_text=="admin")
	{

		var rc = ge("rightCol");
		clearElement(rc);
	
		var file = ce("div","checkinCell");
		file.appendChild(ce("div","formHeader","","Please select file to upload"));
		file.appendChild(createForm("file","uploadfile"));
	
		var cust = ce("div","checkinCell");
		cust.appendChild(ce("div","formHeader","","Custom Version"));
		cust.appendChild(createTextbox("custom_version"));
		
		var n = ce("div","checkinCell");
		n.appendChild(ce("div","formHeader","","Revision Notes"));
		n.appendChild(createTextarea("notes"));
	
		var btns = ce("div","checkinCell");
		btns.appendChild(siteToolbarBtn("Submit File","runFileUpload()","checkin.png"));
		rc.appendChild(btns);
	
		rc.appendChild(file);
		rc.appendChild(cust);
		rc.appendChild(n);
		rc.appendChild(btns);
	
	}

}

function runFileUpload() 
{

	var p = new PROTO();
	p.add("command","docmgr_file_save");
	p.add("unlock","1");
	p.add("object_id",object);
	p.add("custom_version",ge("custom_version").value);
	p.add("notes",ge("notes").value);

	var url = DOCMGR_API + "?" + p.encodeData();

 	closeKeepAlive();

  document.pageForm.action = url;
  document.pageForm.target = "uploadframe";
  document.pageForm.submit();

  timer = setInterval("checkUpload()","100");

}

function checkUpload() 
{

  //this was so much cleaner w/o ie handling
  if (document.all) 
	{

    var tmp = window.frames["uploadframe"].document;

    if (tmp.XMLDocument) var txt = tmp.XMLDocument.documentElement;
    else return false;

  }
  else var txt = window.frames["uploadframe"].document;

  var err = txt.getElementsByTagName("error");
  var success = txt.getElementsByTagName("success");

  if (err.length > 0 || success.length > 0) {

    clearSiteStatus();
    clearInterval(timer);

    //if success just refresh, otherwise show the error
    if (success.length > 0) 
		{
			objpage = "loadCheckinPage";
			loadObjInfo();
    } else 
		{
      alert(err[0].firstChild.nodeValue);
    }

    //again, ie...
    if (document.all) 
		{
      window.frames["uploadframe"].document.open();
      window.frames["uploadframe"].document.write("");
      window.frames["uploadframe"].document.close();
    } else 
		{
      clearElement(window.frames["uploadframe"].document);
    }

  }

}

function checkout() 
{

	objpage = "loadCheckinPage";

	var p = new PROTO();
	p.add("command","docmgr_file_get");
	p.add("object_id",object);
	p.add("lock",1);
	p.redirect(DOCMGR_API);

	//set a delay for 5 seconds and reload the objectInfo 
	setTimeout("loadObjInfo()","2000");

}


function isLockOwner(objinfo)
{

  var ret = false;

  for (var i=0;i<objinfo.lock_owner.length;i++)
  {

    if (objinfo.lock_owner[i]==USER_ID)
    {
      ret = true;
      break;
    }
   
  }
 
  return ret;
 
}
